/* BuddyController.h created by epeyton on Thu 18-Mar-1999 */

#import <AppKit/AppKit.h>

@class BuddyItem, GroupItem;


@interface BuddyController : NSObject
{
    id 					window;
    id					tabView;
    id					onlineListView;
    id					setupListView;
    id					onlineScrollView;
    id					setupScrollView;
    id					onlineContentView;
    id					setupContentView;
    id	onlineTabItem;
    id  setupTabItem;
    
    NSMutableArray 		*groups;		// Array of GroupItems
    NSMutableArray 		*buddies;		// Array of BuddyItems
	
}

- (NSMutableArray *)buddies;
- (NSMutableArray *)groups;
- (NSArray *)sortedGroups;

- (void)createBuddiesFromDict:(NSDictionary *)aDict;
- (void)createGroupsFromDict:(NSDictionary *)aDict;

- (void)setupOnlineListView;
- (void)setupSetupListView;

- (void)addBuddyItem:(BuddyItem *)anItem;
- (void)removeBuddyItem:(BuddyItem *)anItem;
- (void)addGroupItem:(GroupItem *)anItem;
- (void)removeGroupItem:(GroupItem *)anItem;

- (void)buddyLoggedOn:(NSString *)buddyName forService:(NSString *)serviceName;
- (void)buddyLoggedOff:(NSString *)buddyName forService:(NSString *)serviceName;
- (void)removeFromDisplayBuddyNamed:(NSString *)buddyName;

- (void)updateView;
- (void)update;
- (void)display;
- (void)save;

- (void)cleanUpGroups;

- (NSWindow *)window;

// Action messages
- (void)addBuddy:(id)sender;
- (void)addGroup:(id)sender;
- (void)removeItem:(id)sender;
- (void)getInfoForSelected:(id)sender;

- (void)sendMessageToBuddy:(id)sender;
- (void)sendChatRequest:(id)sender;

@end
