/* BuddyItem.h created by epeyton on Sat 27-Mar-1999 */

#import <AppKit/AppKit.h>

@interface BuddyItem : NSObject
{
    NSString		*buddyName;
    NSString		*service;
    NSString 		*displayName;

    BOOL			justLoggedOn;
    BOOL			justLoggedOff;

    NSTimer 		*currentTimer;

    NSDate 			*memberSince;
    NSDate 			*onlineSince;
    NSDate 			*idleStartTime;
    NSString 		*genericStatus;
    unsigned int 	warningLevel;
}

+ (BuddyItem *)buddyNamed:(NSString *)aName;
+ (BuddyItem *)buddyNamed:(NSString *)aName forService:(NSString *)serviceName;
// this is when an existing buddies name may have changed
+ (void)updateBuddyNamed:(NSString *)aName withBuddyItem:(BuddyItem *)buddyItem;
+ (void)removeBuddyNamed:(NSString *)aName;

+ (void)newBuddyItem;
+ (void)newBuddyItemWithGroup:(GroupItem *)aGroup;

+ (NSString *)displayNameForTarget:(NSString *)targetName;

+ (NSArray *)buddiesForService:(NSString *)serviceName;

- (id)initWithBuddyName:(NSString *)aName;

- (void)getInfo;

// Accessors
- (void)setBuddyName:(NSString *)aName;
- (NSString *)buddyName;

- (void)setService:(NSString *)aName;
- (NSString *)service;

- (void)setDisplayName:(NSString *)aName;
- (NSString *)displayName;

- (NSString *)displayString;

- (NSDate *)memberSince;
- (void)setMemberSince:(NSDate *)date;

- (NSDate *)onlineSince;
- (void)setOnlineSince:(NSDate *)date;

- (NSDate *)idleStartTime;
- (void)setIdleStartTime:(NSDate *)date;

- (unsigned int)warningLevel;
- (void)setWarningLevel:(unsigned int)level;

// for supporting multiple platforms
- (NSString *)genericStatus;
- (void)setGenericStatus:(NSString *)aStatus;

- (void)prepareForRemoval;

- (void)editWithGroup:(GroupItem *)aGroup;

- (BOOL)justLoggedOn;
- (BOOL)justLoggedOff;

- (void)setJustLoggedOn;
- (void)setJustLoggedOff;

- (BOOL)isNonBuddy;

@end
