/* ICQService.m created by epeyton on Sun 25-Jul-1999 */

#import "ICQService.h"
#import "MainController.h"

@implementation ICQService

+ (void)initialize 
{
	static BOOL fInitialized = NO;

	[super initialize];
	if (fInitialized)
		return;
    fInitialized = YES;

    NSLog(@"ICQ Service Initialized");
}

+ sharedInstance
{
    static id sInst;

    if (!sInst) {
        sInst = [[ICQService alloc] init];
    }
    return sInst;
}

- (id)init
{
    self = [super init];

    [NSBundle loadNibNamed:@"ICQService" owner:self];

    communicationController = [ICQCommunicationController sharedInstance];

/*
    if ([[NSUserDefaults standardUserDefaults] boolForKey:ICQ_AUTO_LOGIN]) {
        //[self connect];
    }
*/
    
    return self;
}

- (NSString *)serviceName
{
    return ICQ_SERVICE;
}

- (void)awakeFromNib
{
    NSString *screenNameString, *passwordString;
    
	if ([[self superclass] instancesRespondToSelector:@selector(awakeFromNib)])
		[super awakeFromNib];

	screenNameString = [[NSUserDefaults standardUserDefaults] stringForKey:ICQ_UIN_DEFAULT_TEXT];
    passwordString = [[NSUserDefaults standardUserDefaults] stringForKey:ICQ_PASSWORD_DEFAULT_TEXT];

    if (screenNameString != nil)
        [uinText setStringValue:screenNameString];
    else
        [uinText setStringValue:EMPTY_STRING];

    if ((passwordString != nil) && [[NSUserDefaults standardUserDefaults] boolForKey:ICQ_SAVE_PASSWORD]) 
	{
        [passwordText setStringValue:passwordString];
        // [loginCheck setEnabled:YES];
    } 
	else 
	{
        [passwordText setStringValue:EMPTY_STRING];
        // [loginCheck setEnabled:NO];
    }

    [savePasswordCheck setIntValue:[[NSUserDefaults standardUserDefaults] boolForKey:ICQ_SAVE_PASSWORD]];
    // [loginCheck setIntValue:[[NSUserDefaults standardUserDefaults] integerForKey:ICQ_AUTO_LOGIN]];

    return;
} 

- (void)changePreference:(id)sender
{
    if ([savePasswordCheck intValue]) 
	{
        [[NSUserDefaults standardUserDefaults] setObject:[passwordText stringValue] forKey:ICQ_PASSWORD_DEFAULT_TEXT];
        
        // turn on the auto-login feature
       // [loginCheck setEnabled:YES];
    } 
	else 
	{
        // remove any default text that may be around
        [[NSUserDefaults standardUserDefaults] setObject:EMPTY_STRING forKey:ICQ_PASSWORD_DEFAULT_TEXT];
        // [loginCheck setEnabled:NO];
        // [loginCheck setIntValue:NO];
        [[NSUserDefaults standardUserDefaults] setInteger:NO forKey:ICQ_AUTO_LOGIN];
    }
    
    [[NSUserDefaults standardUserDefaults] setBool:[savePasswordCheck intValue] forKey:ICQ_SAVE_PASSWORD];
    

    // [[NSUserDefaults standardUserDefaults] setBool:[loginCheck intValue] forKey:ICQ_AUTO_LOGIN];

    [[NSUserDefaults standardUserDefaults] setObject:[uinText stringValue] forKey:ICQ_UIN_DEFAULT_TEXT];

    [[NSUserDefaults standardUserDefaults] synchronize];
}


- (void)connect
{
    [self changePreference:self];
    
    // Need to check for lengths and refuse of either too short
    if ([[passwordText stringValue] length] < 1) {
       	return;
    }

    if ([[uinText stringValue] length] < 1) {
        return;
    }
	// no autologin for icq ...
    [communicationController loginForUser:[uinText stringValue] password:[passwordText stringValue]];
}

- (void)disconnect
{
    [communicationController shutdownServices];
    [[NSApp delegate] disconnectAllUsersWithService:ICQ_SERVICE];
    return;
}

- (id)displayView
{
    return displayView;
}

@end
