/* mICQCFunctions.m created by epeyton on Fri 09-Jul-1999 */
 
#import "mICQCFunctions.h"
#import "ConsoleController.h"
#import "BuddySearch.h"
#import "BuddyItem.h"
#import "BuddyController.h"
#import "MainController.h"

static BOOL loggedOn = NO;

void f_icq_SrvAck(unsigned short seq)
{
    //static int counter = 0;
    //counter++;

    //if (loggedOn) {
    //	send_icq_contacts();
    //}
    //[[ConsoleController sharedInstance] addMessageToConsole:@"ICQ - Server Ack"];
    
    return;
}

void f_icq_Logged(void)
{
    [[ConsoleController sharedInstance] addMessageToConsole:@"ICQ - Logged on"];
    //send_icq_contacts();
    loggedOn = YES;
    
    return;
}


void f_icq_Disconnected(void)
{
    [[ConsoleController sharedInstance] addMessageToConsole:@"ICQ - Disconnected"];
    [[ICQCommunicationController sharedInstance] shutdownServices];

    return;
}


void f_icq_RecvMessage(unsigned long uin, unsigned char hour, unsigned char minute, unsigned char day, unsigned char month, unsigned short year, const char *msg)
{
    [[NSApp delegate] chatWindowForUser:[[NSNumber numberWithLong:uin] stringValue] withMessage:[NSString stringWithCString:msg] isAutoReply:NO forService:ICQ_SERVICE];

    return;
}


void f_icq_RecvURL(unsigned long uin, unsigned char hour, unsigned char minute, unsigned char day, unsigned char month, unsigned short year, const char *url, const char *descr)
{
    [[NSApp delegate] chatWindowForUser:[[NSNumber numberWithLong:uin] stringValue] withMessage:[NSString stringWithCString:url] isAutoReply:NO forService:ICQ_SERVICE];

    return;
}


void f_icq_RecvAdded(unsigned long uin, unsigned char hour, unsigned char minute, unsigned char day, unsigned char month, unsigned short year, const char *nick, const char *first, const char *last, const char *email)
{
    NSRunAlertPanel(INFORMATION, @"A user has added you to their contact list.\n\tUser Name:%d\n\tNick Name:%s\n\tFirst Name:%s\n\tLast Name:%s\n\tLast Name:%s", OK_BUTTON, nil, nil, uin, nick, first, last, email);
}

void f_icq_RecvAuthReq(unsigned long uin, unsigned char hour, unsigned char minute, unsigned char day, unsigned char month, unsigned short year, const char *nick, const char *first, const char *last, const char *email, const char *reason)
{
    id msgString = [NSString stringWithFormat:@"A user has requested your authorization to add you to their contact list\n\tUser Name:%@\n\tFirst Name:%@\n\tLast Name:%@\n\tEmail Address:%@\n\tReason:%@\n\t", [[NSNumber numberWithLong:uin] stringValue], [NSString stringWithCString:first], [NSString stringWithCString:last], [NSString stringWithCString:email], [NSString stringWithCString:reason]];
    if (NSRunAlertPanel(INFORMATION, msgString, OK_BUTTON, REFUSE_BUTTON, nil) == NSOKButton) {
        icq_SendAuthMsg(uin);
    }

    return;
}


void f_icq_UserFound(unsigned long uin, const char *nick, const char *first, const char *last, const char *email, char auth)
{
    NSMutableArray *userNameArray = [NSMutableArray array];

    [userNameArray addObject:[[NSNumber numberWithLong:uin] stringValue]];    

    [[BuddySearch sharedBuddySearch] setFoundUserNames:userNameArray];

    return;
}


void f_icq_SearchDone(void)
{
    [[ConsoleController sharedInstance] addMessageToConsole:@"Search Completed"];

    return;
}


void f_icq_UserOnline(unsigned long uin, unsigned long status, unsigned long ip, unsigned long port, unsigned long real_ip)
{
    [[[NSApp delegate] buddyController] buddyLoggedOn:[[NSNumber numberWithLong:uin] stringValue] forService:ICQ_SERVICE];
    f_icq_UserStatusUpdate(uin, status);

    return;
}

void f_icq_UserOffline(unsigned long uin)
{
    [[[NSApp delegate] buddyController] buddyLoggedOff:[[NSNumber numberWithLong:uin] stringValue] forService:ICQ_SERVICE];

    return;
}


void f_icq_UserStatusUpdate(unsigned long uin, unsigned long status)
{
    id msgString;
    
    switch (status) {
        case STATUS_ONLINE:
            msgString = @"";
            break;
        case STATUS_DND:
            msgString = @"Do Not Disturb";
            break;
        case STATUS_OFFLINE:
            msgString = @"";
            break;
        case STATUS_INVISIBLE:
            msgString = @"Invisible";
            break;
        case STATUS_INVISIBLE_2:
            msgString = @"Invisible 2";
            break;
        case STATUS_NA:
            msgString = @"NA";
            break;
        case STATUS_FREE_CHAT:
            msgString = @"Free For Chat";
            break;
        case STATUS_OCCUPIED:
            msgString = @"Occupied";
            break;
        case STATUS_AWAY:
            msgString = @"Away";
            break;
        default:
            msgString = @"";
            break;
    }

    [[[NSApp delegate] buddyController] buddyLoggedOn:[[NSNumber numberWithLong:uin] stringValue] forService:ICQ_SERVICE];

    [[BuddyItem buddyNamed:[[NSNumber numberWithLong:uin] stringValue]] setGenericStatus:msgString];

    [[[NSApp delegate] buddyController] display];



    return;
}


void f_icq_InfoReply(unsigned long uin, const char *nick, const char *first, const char *last, const char *email, char auth)
{
    NSMutableDictionary *aDict = [NSMutableDictionary dictionary];
    [aDict setObject:[[NSNumber numberWithLong:uin] stringValue] forKey:SCREENNAME];
    [aDict setObject:[NSString stringWithFormat:@"Nick: %s\nFirst: %s\nLast: %s\nEmail: %s\nAuth: %s", nick, first, last, email, auth] forKey:PROFILE_TEXT]; 
    [[NSApp delegate] displayUserInfoDictionary:aDict];

    return;
}


void f_icq_ExtInfoReply(unsigned long uin, const char *city, unsigned short country_code, char country_stat, const char *state, unsigned short age, char gender, const char *phone, const char *hp, const char *about)
{
    return;
}


void f_icq_Log(time_t time, unsigned char level, const char *str)
{
	[[ConsoleController sharedInstance] addMessageToConsole:[NSString stringWithFormat:@"ICQ - Log:%s", str]];

    return;
}

void send_icq_contacts()
{
    NSEnumerator *buddyEnum = nil;
    id aBuddy = nil;
    static int sent = 0;

    if (sent <= 3) { // only try 3 times to send buddies

        // send buddy list ...
        buddyEnum = [[BuddyItem buddiesForService:ICQ_SERVICE] objectEnumerator];

        while (aBuddy = [buddyEnum nextObject]) {
            icq_ContAddUser([[aBuddy buddyName] intValue]);
        }
        sent ++;
    }

    return;
}

